from pydantic import Field, TypeAdapter
from typing import Optional,Dict, Any, List
from datetime import datetime


from api.schemas.base import Base
from api.db.tables.events import EventState,EventStatus


class ListEventUpdate(Base):
    # id: Optional[int] = None
    name: Optional[str] = Field(None, max_length=40)
    title: Optional[str] = Field(None, max_length=64)
    # creator_id: Optional[int] = None
    # created_at: Optional[datetime]= None
    schema: Optional[Dict[str, Any]]= None
    state: Optional[EventState]= None
    status: Optional[EventStatus]= None

class AllListEvent(Base):
    id: int
    name: str
    title: str
    creator_id: int
    created_at: datetime
    schema: Dict[str, Any] = Field(default={})
    state: EventState
    status: EventStatus


class AllListEventResponse(Base):
    list_event: List[AllListEvent]
    amount_count: int
    amount_pages: int
    current_page: int
    limit: int

all_list_event_adapter = TypeAdapter(List[AllListEvent])
